<template>
  <q-page padding class="height-0">
    <q-scroll-area class="full-height" :thumb-style="{right: '0', borderRadius: '4px', background: '#d12', opacity: .6, width: '10px'}">
      <div class="q-headline q-mb-sm">Project Overview</div>
      <div class="q-ma-xs">
        <div class="row items-stretch gutter-sm" v-if="stats && stats.id">
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center cursor-pointer" @click.native="$router.push({ name: 'upload' })">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.cameras_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">Cameras</div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center cursor-pointer" @click.native="$router.push({ name: 'upload' })">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.recorded_segment_raw_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Footage
                  <div class="q-pt-lg text-faded"><small>Uploaded videos</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.recorded_segment_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Footage
                  <div class="q-pt-lg text-faded"><small>Imported segments</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center cursor-pointer" @click.native="$router.push({ name: 'uplmeta' })">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.users_info_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Metadata
                  <div class="q-pt-lg text-faded"><small>Runners imported</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center cursor-pointer" @click.native="$router.push({ name: 'uplmeta' })">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.users_logs_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Metadata
                  <div class="q-pt-lg text-faded"><small>Timing points imported</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center">
              <q-card-title>
                <div v-if="stats.intro_count > 0" class="q-pt-lg text-center q-display-1 text-positive">
                  OK
                  <q-icon name="check" />
                </div>
                <div v-else class="q-pt-lg text-center q-display-1 text-negative">
                  NOT OK
                  <q-icon name="error" />
                </div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Media pack
                  <div class="q-pt-lg text-faded"><small>Intro uploaded</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center">
              <q-card-title>
                <div v-if="stats.outro_count > 0" class="q-pt-lg text-center q-display-1 text-positive">
                  OK
                  <q-icon name="check" />
                </div>
                <div v-else class="q-pt-lg text-center q-display-1 text-negative">
                  NOT OK
                  <q-icon name="error" />
                </div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Media pack
                  <div class="q-pt-lg text-faded"><small>Outro uploaded</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center">
              <q-card-title>
                <div v-if="stats.soundtrack_count > 0" class="q-pt-lg text-center q-display-1 text-positive">
                  OK
                  <q-icon name="check" />
                </div>
                <div v-else class="q-pt-lg text-center q-display-1 text-negative">
                  NOT OK
                  <q-icon name="error" />
                </div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Media pack
                  <div class="q-pt-lg text-faded"><small>Soundtrack uploaded</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.users_clips_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Publish
                  <div class="q-pt-lg text-faded"><small>Generated videos</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row">
            <q-card class="row col justify-center cursor-pointer" @click.native="$router.push({ name: 'videos' })">
              <q-card-title>
                <div class="q-pt-lg text-center q-display-1">{{(stats.users_clips_published_count || 0).toLocaleString()}}</div>
                <div class="q-pt-lg text-center q-title text-dark" slot="subtitle">
                  Publish
                  <div class="q-pt-lg text-faded"><small>Published videos</small></div>
                </div>
              </q-card-title>
            </q-card>
          </div>
        </div>
      </div>
      <div class="q-headline q-mt-lg q-mb-sm">Lifetime Statistics</div>
      <div class="q-ma-xs">
        <div class="row items-stretch gutter-sm">
          <div class="col-12 col-md-6 col-lg-4 col-xl-3 row justify-center items-center">
            <q-btn size="lg" @click="openURL(channel.dashboard_url)"
              :color="!channel || !channel.dashboard_url ? 'faded' : 'primary'"
              :disable="!channel || !channel.dashboard_url"
            >
              Dive into Analytics
            </q-btn>
          </div>
        </div>
      </div>
    </q-scroll-area>
  </q-page>
</template>

<script>
  import { openURL } from 'quasar';
  import { CancelToken, isCancel } from 'axios';
  import { showRejectionMessage } from '../../utils';

  export default {
    name: 'irwOverview',
    data() {
      return {
        stats: {},
        channel: {},
      };
    },
    computed: {
      location: {
        get() {
          return this.$store.state.location.location;
        },
      },
    },
    methods: {
      openURL,
      load(idLocation) {
        if (this.cancelS) this.cancelS.cancel();
        this.cancelS = CancelToken.source();
        return this.$http
          .get('/locations/status', {
            params: {
              location_id: idLocation,
            },
            cancelToken: this.cancelS.token,
          })
          .then((response) => {
            this.stats = response.data.results.length ? response.data.results[0] : {};
            return response;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading location stats.');
            }
            this.stats = {};
            return Promise.reject(rejection);
          });
      },
      loadChannel() {
        if (!this.location) {
          this.channel = {};
          return false;
        }
        if (this.cancelC) this.cancelC.cancel();
        this.cancelC = CancelToken.source();
        return this.$http
          .get('/channels/list', {
            params: {
              channel_id: this.location.portal_channel_id,
            },
            cancelToken: this.cancelC.token,
          })
          .then((response) => {
            this.channel = response.data.results.length ? response.data.results[0] : {};
            return response;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading channel info.');
            }
            this.channel = {};
            return Promise.reject(rejection);
          });
      },
    },
    beforeRouteUpdate(to, from, next) {
      this
        .load(to.params.idLocation)
        .then(next);
    },
    watch: {
      'location.portal_channel_id': function load() {
        this.loadChannel();
      },
    },
    mounted() {
      this.load(this.$route.params.idLocation);
      this.loadChannel();
    },
    beforeDestroy() {
      if (this.cancelS) this.cancelS.cancel();
      if (this.cancelC) this.cancelC.cancel();
    },
  };
</script>
